package MG::DSP;

use Parse;
use Agent::DSP;
use Agent::T3;
use MG::RC;
use Net::Telnet;
use strict;


sub new {
  my($class, $dev) = @_;

  my $obj = { dev => $dev , READONLY => 1};
  bless($obj, "MG::DSP");
  return $obj;
}

sub dev {
  my($obj) = @_;
  return $obj->{dev};
}


# retrn (error, $t);
sub connect {
  my($obj, $force) = @_;
  return (undef,$obj->{connect}) if ($obj->{connect} && !$force);

  my $dev = $obj->{dev};
  my $t  = new Net::Telnet (
              errmode   => "return",
              Timeout   => 400,
              Prompt    => '/[#?] $/'
               );

   if (!defined($t->open($dev->{ipno}))) {
      return ("Cannot open $dev->{ipno}");
   }
   $t->max_buffer_length(1900000);

   $t->login("root", Agent::T3->getPassword($dev) || "X");
   if ($t->errmsg()) {
      return ($t->errmsg());
   }
   $obj->{connect} = $t;
   $t->cmd("no page-mode");
   $t->cmd("terminal width 200");
   return (undef, $t);
}


sub runCommand {
  my($obj, $list) = @_;
  
  my ($err, $t) = $obj->connect();
  my $rc = MG::RC->new();
  $rc->{err} = $err;
  return $rc if ($err);
  my(@RC);
  foreach my $l (@$list) {
     my @o1 = $t->cmd($l);
     push(@RC, [$l, \@o1]);
  }
  $rc->{report} = \@RC;
  return $rc;
}

sub fix_fru {
  my($class, $fru) = @_;
  return $fru;
}
  

sub pre_disable {

  my($obj, $fru) = @_;
  my $warn;
  my $dev = $obj->dev();
  $fru = $obj->fix_fru($fru);
  my ($err, $t) = $obj->connect();
  my $rc = MG::RC->new();
  $rc->{err} = $err;
  return $rc if ($err);

  my @o4 = $t->cmd("show chassis");
  $t->cmd("exit");

  $rc->{report} =  [
     ["Show Chassis", \@o4 ],
     ];

  return MG::RC::end($rc);

}



1;



  
